
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>MySQL · myrocks · myrocks写入分析 / iVAN</title>

    <meta name="description" content="MySQL · myrocks · myrocks写入分析 写入流程 myrocks的写入流程可以简单的分为以下几步来完成 将解析后的记录(kTypeValue/kTypeDeletion)写入到WriteBatch中 将WAL日志写入log文件 将WriteBatch中的内容写到memtable中,事务完成 其中第2,3步在提交时完成 WriteBatch与Myrocks事务处理密切相关,事务中的记录提交前都以字符串的形式存储在WriteBatch-&gt;rep_中,要么都提交,要么都回滚. 回滚的逻辑比较简单,只需要清理WriteBatch-&gt ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">MySQL · myrocks · myrocks写入分析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>写入流程</h2>
<p>myrocks的写入流程可以简单的分为以下几步来完成</p>
<ol>
<li>将解析后的记录(kTypeValue/kTypeDeletion)写入到WriteBatch中</li>
<li>将WAL日志写入log文件</li>
<li>将WriteBatch中的内容写到memtable中，事务完成</li>
</ol>
<p>其中第2，3步在提交时完成</p>
<blockquote><p>WriteBatch与Myrocks事务处理密切相关，事务中的记录提交前都以字符串的形式存储在WriteBatch-&gt;rep_中，要么都提交，要么都回滚。 回滚的逻辑比较简单，只需要清理WriteBatch-&gt;rep_即可。详见TransactionImpl::Rollback</p></blockquote>
<p>一个简单的insert 写入WriteBatch堆栈如下</p>
<pre><code>#0  rocksdb::WriteBatchInternal::Put
#1  rocksdb::WriteBatch::Put
#2  myrocks::ha_rocksdb::update_pk
#3  myrocks::ha_rocksdb::update_indexes
#4  myrocks::ha_rocksdb::update_write_row
#5  myrocks::ha_rocksdb::write_row
#6  handler::ha_write_row
#7  write_record
#8  mysql_insert
#9  mysql_execute_command
#10 mysql_parse
#11 dispatch_command
#12 do_command
#13 do_handle_one_connection
</code></pre>
<p>一个简单的insert commit堆栈如下</p>
<pre><code>#0  rocksdb::InlineSkipList&lt;rocksdb::MemTableRep::KeyComparator const&amp;&gt;::Insert
#1  rocksdb::(anonymous namespace)::SkipListRep::Insert
#2  rocksdb::MemTable::Add
#3  rocksdb::MemTableInserter::PutCF
#4  rocksdb::WriteBatch::Iterate
#5  rocksdb::WriteBatch::Iterate
#6  rocksdb::WriteBatchInternal::InsertInto
#7  rocksdb::DBImpl::WriteImpl
#8  rocksdb::DBImpl::Write
#9  rocksdb::TransactionImpl::Commit
#10 myrocks::Rdb_transaction_impl::commit_no_binlog
#11 myrocks::Rdb_transaction::commit
#12 myrocks::rocksdb_commit
#13 ha_commit_low
#14 TC_LOG_MMAP::commit
#15 ha_commit_trans
#16 trans_commit_stmt
#17 mysql_execute_command
#18 mysql_parse
#19 dispatch_command
#20 do_command
#21 do_handle_one_connection
</code></pre>
<h2>提交流程及优化</h2>
<p>这里只分析rocksdb引擎的提交流程，实际MyRocks提交时还需先写binlog(binlog开启的情况).</p>
<p>rocksdb引擎提交时就完成两个事情  <br />
1. 写WAL日志(WAL开启的情况下rocksdb_write_disable_wal=off)<br />
2. 将之前的WriteBatch写入到memtable中</p>
<p>然而，写WAL是一个串行操作。为了提高提交的效率， rocksdb引入了group commit机制。</p>
<p>待提交的事务都依次加入到提交的writer队列中，这个writer队列被划分为一个一个group. 每个group有一个leader， 其他为follower，leader负责批量写WAL。每个group由双向链表link_older， link_newer链接。如下图所示</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYXRhMi1pbWcuY24taGFuZ3pob3UuaW1nLXB1Yi5hbGl5dW4taW5jLmNvbS9jMGRjNmU4ZTNiYzdmNzY0NDg4YmQxZjY1NzQ2N2ZkZi5wbmc=.jpg"></p>
<p>每个writer可能的状态如下</p>
<ul>
<li>Init: writer的初始状态</li>
<li>Header: writer被选为leader</li>
<li>Follower: writer被选为follower</li>
<li>LockedWating: writer在等待自己转变为指定的状态</li>
<li>Completed：writer操作完成</li>
</ul>
<p>writer的状态变迁跟group是否并发写memtable有关<br />
当开启并发写memtable(rocksdb_allow_concurrent_memtable_write=on)且group中的writer至少有两个时，group才会并发写。</p>
<p>group并发写时writer的状态变迁图如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYXRhMi1pbWcuY24taGFuZ3pob3UuaW1nLXB1Yi5hbGl5dW4taW5jLmNvbS9jOGI4OTQ0MzVhYzVmMjI0NWVlZmJkZmQzODJjMWQ4MS5wbmc=.jpg"></p>
<p>group非并发写时writer的状态变迁图如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYXRhMi1pbWcuY24taGFuZ3pob3UuaW1nLXB1Yi5hbGl5dW4taW5jLmNvbS85NDU4Y2Y1MTI3ZmM3NDZiN2I1MzhhYWU5OWIyODk5My5wbmc=.jpg"></p>
<p>源码结构图如下（图片来自林青）<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYXRhMi1pbWcuY24taGFuZ3pob3UuaW1nLXB1Yi5hbGl5dW4taW5jLmNvbS8zMzMwZGIzNGJmODM4ZDk5Y2VkYTU5NzlkNTk2OGUxNC5wbmc=.jpg"></p>
<p>上面的图是在group内writer并发写memtable的情形。<br />
非并发写memtable时，没有LaunchParallelFollowers/CompleteParallelWorker, Insertmemtable是由leader串行写入的。<br />
这里group commit有以下要点<br />
1. 同一时刻只有一个leader, leader完成操作后，才设置下一个leader<br />
2. 需要等一个group都完成后,才会进行下一个group<br />
3. group中最后一个完成的writer负责完成提交和设置下一个leader<br />
4. Leader 负责批量写WAL<br />
5. 只有leader才会去调整双向链表link_older,link_newer.</p>
<p>注意这里2，3 应该可以优化改进为</p>
<ul>
<li>不需要等一个group完成再进行下一个group</li>
<li>不同group的follower可以并发执行</li>
<li>只有leader负责完成提交和设置下一个leader</li>
</ul>
<h2>写入控制</h2>
<p>rocksdb在提交写入时，需考虑以下几种情况,详见PreprocessWrite</p>
<ul>
<li>WAL日志满，WAL日志超过rocksdb_max_total_wal_size，会从所有的colomn family中找出含有最老日志(the earliest log containing a prepared section)的column family进行flush, 以释放WAL日志空间</li>
<li>Buffer满，全局的write buffer超过rocksdb_db_write_buffer_size时，会从所有的colomn family中找出最先创建的memtable进行切换，详见HandleWriteBufferFull</li>
<li>某些条件会触发延迟写
<ul>
<li>max_write_buffer_number &gt; 3且 未刷immutable memtable总数 &gt;=max_write_buffer_number-1</li>
<li>自动compact开启时，level0的文件总数 &gt;= level0_slowdown_writes_trigger</li>
</ul>
</li>
<li>某些条件会触发停写
<ul>
<li>未刷immutable memtable总数 &gt;=max_write_buffer_number</li>
<li>自动compact开启时，level0的文件总数 &gt;= level0_stop_writes_trigger</li>
</ul>
</li>
</ul>
<p>具体可参考RecalculateWriteStallConditions</p>
<h2>总结</h2>
<p>rocksdb写入流程还有优化空间，Facebook也有相关的优化。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-03 07:48:52</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/mysql/" title="mysql">mysql</a>, <a href="https://www.iamivan.net/tag/group/" title="group">group</a>, <a href="https://www.iamivan.net/tag/%e6%97%a5%e5%bf%97/" title="日志">日志</a>, <a href="https://www.iamivan.net/tag/commit/" title="Commit">Commit</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>MySQL · myrocks · myrocks写入分析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN7XDJp.html" rel="bookmark">MyRocks写入分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				title: MySQL · myrocks · myrocks写入分析 author: 张远 写入流程 myrocks的写入流程可以简单的分为以下几步来完成 将解析后的记录(kTypeValue/kTypeDeletion)写入到WriteBatch中 将WAL日志写入log文件 将WriteBatch中的内容写到memtable中,事务完成 其中第2,3步在提交时完成 WriteBatch与Myrocks事务处理密切相关,事务中的记录提交前都以字符串的形式存储在WriteBatch-&gt;rep			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdWODXM.html" rel="bookmark">【MySQL】MyRocks 漫谈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一 前言     最近一两年,数据库技术尤其是MySQL方面的发展可谓百花齐放,TokuDB,MyRocks ,MySQL 5.7 GA,MySQL 8.0 doc release 其软件也在开发当中,ALiSQL 开源.其中有功能上的改进的,也有针对Innodb 本身缺陷(主要是存储空间方面的)做优化的,作为数据库技术方面的从业者多少有些应接不暇.结合今年ACMUG 技术大会上的技术分享,Percona官方对MyRocks的表态,阿里在技术上的研究,落地来看,可以明显感觉到Myrocks是一种			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNkBrp.html" rel="bookmark">mysql表优化、分析、检查和修复的方法详解&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了mysql表优化.分析.检查和修复的方法.分享给大家供大家参考,具体如下: 这里介绍对数据库的管理常规就是进行预防性的维护,以及修复那些出现问题的内容. 进行检查和修复通常具有四个主要的任务: 1. 对表进行优化 2. 对表进行分析(分析并存储MyISAM和BDB表中键的分布) 3. 对表进行检查(检查表的错误,并且为MyISAM更新键的统计内容) 4. 对表进行修复(修复被破坏的MyISAM表) 一.对表进行优化 优化表有很多方式实现: OPTIMIZE TABLE语句.mysq			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgEYvBz.html" rel="bookmark">mysql慢查询日志分析实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.MySQL 慢查询日志分析 pt-query-digest分析慢查询日志 pt-query-digest –report slow.log 报告最近半个小时的慢查询: pt-query-digest –report –since 1800s slow.log 报告一个时间段的慢查询: pt-query-digest –report –since '2013-02-10 21:48:59′ –until '2013-02-16 02:33:50′ slow.log 报告只含select语句的慢			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNm644b.html" rel="bookmark">mysql 查询结果异常分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				title: MySQL · mysql · mysql 查询结果异常分析 author: 张远 现象 查询条件类型变化后,查询出了不正确的结果. create table t1(id int primary key, a varchar(50) DEFAULT NULL, key idx_a(a)) engine=innodb; show create table t1; insert into t1 values(1,'6036000240201612190005565273'); inse			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEJoaqM.html" rel="bookmark">mysql慢查询日志分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一步应该做的就是排查问题,找出瓶颈,所以,先从日志入手 开启慢查询日志 mysql&gt;show variables like &quot;%slow%&quot;; 查看慢查询配置,没有则在my.cnf中添加,如下 log-slow-queries = /data/mysqldata/slowquery.log    #日志目录 long_query_time = 1                          #记录下查询时间查过1秒 log-queries-not-using-indexe			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z46oJ9M.html" rel="bookmark">MySQL 慢查询日志分析及可视化结果</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MySQL 慢查询日志分析及可视化结果 MySQL 慢查询日志分析 pt-query-digest分析慢查询日志 pt-query-digest --report slow.log 报告最近半个小时的慢查询: pt-query-digest --report --since 1800s slow.log 报告一个时间段的慢查询: pt-query-digest --report --since '2013-02-10 21:48:59' --until '2013-02-16 02:33:50'			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPPnk0p.html" rel="bookmark">MySQL &CenterDot; myrocks &CenterDot; data dictionary 分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				data dictionary rocksdb作为mysql的一个新的存储引擎,在存储引擎层,会维护自已的元数据信息.在innodb存储引擎中,我们通过information_schema下的INNODB_SYS_DATAFILES,INNODB_SYS_TABLES,INNODB_SYS_INDEXES等表, 可以窥视innodb的元数据信息.同样,rocksdb通过information_schema下的ROCKSDB_INDEX_FILE_MAP,ROCKSDB_DDL,ROCKSDB_G			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlKZaYb.html" rel="bookmark">MySQL &CenterDot; myrocks &CenterDot; myrocks之备份恢复</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				myrocks支持逻辑备份和物理备份,逻辑备份仍然采用mysqldump,物理备份采用自己开发的myrocks_hotbackup工具,传统的物理备份工具Xtrabackup不支持rocksdb.由于rocksdb的存储特性,myrocks不管是逻辑备份还是物理备份,与innodb的备份恢复均有较大差别. 逻辑备份 myrocks的mysqldump工具支持rocksdb的逻辑备份,其使用方式与原生的mysqldump备份innodb没有区别,一般的使用方式如下 mysqldump -uroot			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MY2lQp.html" rel="bookmark" class="title">【整理】CMake 介绍和 CMake 实践</a>
					<div>
						[CMake 优点]: 开放源代码,使用 BSD 许可证发布. 跨平台,可以生成 native 编译配置文件.在 linux/unix 平台可以生成 makefile,在 mac 平台可以生成 xco ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwXeWb.html" rel="bookmark" class="title">利用SAX解析读取XML文件</a>
					<div>
						xml     这是我的第一个BLOG,今天在看&lt;J2EE应用开发详解&gt;一书,书中讲到XML编程,于是就按照书中的步骤自己测试了起来,可是怎么测试都不成功,后来自己查看了一遍源码,发现在读 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlLX8b.html" rel="bookmark" class="title">如何导出SQL Server中的所有Job</a>
					<div>
						应用场景: 在将源SQL Server数据库服务器中的所有Job(作业)迁移至目标数据库服务器的过程中,需要先将这些Job导出为SQL脚本. 操作步骤: 1.在Microsoft SQL Server ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myrv2lp.html" rel="bookmark" class="title">C&plus;&plus;中优化BOOL变量的声明</a>
					<div>
						通常我们会这样声明BOOL 变量: class CMyClass { ... BOOL m_bVar1; BOOL m_bVar2; BOOL m_bVar3; BOOL m_bVar4; BOOL  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQP7LQz.html" rel="bookmark" class="title">PhotoShop制作风车转动GIF动态效果动画教程</a>
					<div>
						教大家用PhotoShop制作一个风车转动的GIF动态效果,从风车制作到动画都有详细过程,喜欢的同学可以学习一下! 效果图: 素材: 1.新建 2.打开一张素材,拖入文档中,CTRL+T调整到适当大小 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRdKrp.html" rel="bookmark" class="title">win7系统自带的剪贴板功能如何打开？</a>
					<div>
						  win7系统自带的剪贴板功能如何打开?          具体方法如下: 1.点击&quot;开始&quot;菜单,在&quot;搜索程序和文件&quot;搜索栏中输入&quot;cmd&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywEOJz.html" rel="bookmark" class="title">小米手环怎么绑定与解绑手机？</a>
					<div>
						    小米手环怎么绑定与解绑手机? 1.将你的手环摆放在桌边上,并将手机放在旁边(小米手环的绑定有范围限制,特别是当周围有多个手环时,会优先绑定最靠近手机的手环) 2.打开你的小米运动APP,点击右 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJ71np.html" rel="bookmark" class="title">Android涉及到的设计模式&lpar;转&rpar;</a>
					<div>
						1.适配器模式:ListView或GridView的Adapter 简介:不同的数据提供者使用一个适配器来向一个相同的客户提供服务.   2.建造者模式:AlertDialog.Builder 简介: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP87VDp.html" rel="bookmark" class="title">编程c语言-i&amp;amp&semi;amp&semi;lt&semi;&equals;sqrt&lpar;n&rpar;&semi;这种情况为什么也可以判断是不是素数？</a>
					<div>
						问题描述 i&lt;=sqrt(n);这种情况为什么也可以判断是不是素数? i &lt;n;这种情况就是用 n 分别除以2,3,--,一直到小于n,如果都除不尽的话,就说n是素数.但实际上不用那么麻烦 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24onkp.html" rel="bookmark" class="title">正则表达式的高级技巧分享&lowbar;正则表达式</a>
					<div>
						正则表达式(regular expression abbr. regex) 功能强大,能够用于在一大串字符里找到所需信息.它利用约定俗成的字符结构表达式来发生作用.不幸的是,简单的正则表达式对于一些高 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3wWEz.html" rel="bookmark" class="title">hibernate5&lpar;7&rpar;操纵对象入门&lbrack;2&rsqb;四大对象状态分析</a>
					<div>
						状态类型 在hibernate中,java对象的声明周期对应有4种状态: 状态 说明 瞬时(Transient) 由new操作符创建,且尚未与Hibernate Session 关联的对象被认定为瞬时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6EDjz.html" rel="bookmark" class="title">微软表示 Windows Phone 8 SDK 使用情况乐观</a>
					<div>
						作为上周BUILD开发者大会的一部分,微软发布了最终版本的Windows Phone 8 SDK工具包.现在,随着诺基亚Lumia 920和820的开售,目前最大的疑问就是软件开发者是否对WP8软件的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWmX6p.html" rel="bookmark" class="title">net-mysql数据库查询的格式化</a>
					<div>
						问题描述 mysql数据库查询的格式化 本人按一个日期段查询表的记录,为保证统一的处理方式,想让查询结果自动补全,如下所示: billRec 100元,5人,2015-09-15 200元,6人,20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7oBAz.html" rel="bookmark" class="title">大学生入伍下周上网咨询</a>
					<div>
						据新华社电 10月22日至115.html&quot;&gt;26日,教育部高校学生司.全国学生资助管理中心.全国高等学校http://www.aliyun.com/zixun/aggregation ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3AY4z.html" rel="bookmark" class="title">squid-2&period;6&period;STABLE23之Web反向代理加速实做</a>
					<div>
						Squid是一种在Linux系统下使用的优秀的代理服务器软件. squid不仅可用在Linux系统上,还可以用在AIX.Digital Unix.FreeBSD.HP-UX.Irix.NetBSD.N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW2P9jb.html" rel="bookmark" class="title">服务器-iis 请求后缀，恭待高人来答，欢迎</a>
					<div>
						问题描述 iis 请求后缀,恭待高人来答,欢迎 情景: 本地服务器路径为e:wwwroot 有文件为e:wwwrootcode.php 需求 访问输入路径访问http://127.0.0.1/code ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKOmYb.html" rel="bookmark" class="title">java-杭电acm1106为什么就是WA求解释，看了大牛的思想，结果输出正确</a>
					<div>
						问题描述 杭电acm1106为什么就是WA求解释,看了大牛的思想,结果输出正确 排序 Problem Description 输入一行数字,如果我们把这行数字中的'5'都看成空格,那么就得到一行用空格 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxY4OQp.html" rel="bookmark" class="title">windows 7 下快速搭建php环境&lpar;windows7&plus;IIS7&plus;php&plus;mysql&rpar;</a>
					<div>
						原文:windows 7 下快速搭建php环境(windows7+IIS7+php+mysql) 1).采用理由: 优点:最大化的桌面图形化操作系统,可维护性优秀.基于IIS v6.0/v7.0(20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydA5db.html" rel="bookmark" class="title">新站4天获取的战绩数据分享</a>
					<div>
						7月27日的凌晨,我的http://www.aliyun.com/zixun/aggregation/34518.html&quot;&gt;独立域名博客正式推出,到现在接近有4天的时间了,特此为大家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdR4N3b.html" rel="bookmark" class="title">手机银行木马Faketoken又更新，利用屏幕重叠窃取银行信息</a>
					<div>
						本文讲的是手机银行木马Faketoken又更新,利用屏幕重叠窃取银行信息,近日,卡巴斯基实验室的安全研究人员发现了一个名为Faketoken的Android银行木马的新版本,它可以检测并记录受感染设备 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBZnrM.html" rel="bookmark" class="title">leetcode 22 Generate Parentheses关于C&plus;&plus; string的问题</a>
					<div>
						问题描述 leetcode 22 Generate Parentheses关于C++ string的问题 /* Given n pairs of parentheses, write a functi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkY5mM.html" rel="bookmark" class="title">一个删除指定表的所有索引和统计的过程&lowbar;mssql2005</a>
					<div>
						复制代码 代码如下: ------------------------------------------------------------------------ -- Author : Happ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8YY2b.html" rel="bookmark" class="title">如何保护网站安全增强网站安全性能</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 对于网站来说除了要有很好的内容还要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrKOnp.html" rel="bookmark" class="title">Yii框架连接数据库学习笔记</a>
					<div>
						配置数据库连接 在protected/config/main.php文件中:  代码如下 复制代码 'db'=&gt;array(  'connectionString'=&gt;'mysql:hos ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk0vgyz.html" rel="bookmark" class="title">自动完成JS类&lpar;纯JS&comma; Ajax模式&rpar;&lowbar;javascript技巧</a>
					<div>
						一. 封装的JS文件 //******************************************************** //创建日期: 2009-03-10 //作 者: oloe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Nl4lb.html" rel="bookmark" class="title">最简单纯JavaScript实现Tab标签页切换的方式&lpar;推荐&rpar;&lowbar;javascript技巧</a>
					<div>
						先说一下最土的一种方法: Html: &lt;div class=&quot;tab-head&quot;&gt; &lt;h2 id=&quot;tab1&quot; onmouseover=&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ26lqz.html" rel="bookmark" class="title">js修改input的type属性及浏览器兼容问题探讨与解决&lowbar;javascript技巧</a>
					<div>
						js修改input的type属性有些限制.当input元素还未插入文档流之前,是可以修改它的值的,在ie和ff下都没问题.但如果input已经存在于页面,其type属性在ie下就成了只读属性了,不可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmV1Zwz.html" rel="bookmark" class="title">工作前后问题</a>
					<div>
						问题描述 我是一个即将从事java行业的虾米.我想问问在公司面试前应该注意些什么,进公司了又要准备什么?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDklEOp.html" rel="bookmark" class="title">c&num;动态报表制作&lpar;winform&rpar;中</a>
					<div>
						问题描述 如何用c#制作动态报表(winform)!我是初学者,以前没做过报表! 解决方案 解决方案二:你想做报表?用水晶报表组件没?解决方案三:你这个动态报表能具体说说是什么要求嘛,不然我们怎么知道 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXdRNyp.html" rel="bookmark" class="title">撬开O2O：免费WiFi项目如何打造核心竞争力？</a>
					<div>
						微博上有个段子广为流传:海边度假酒店老板说各国游客来了需求都不一样: 法国人来了问这附近美女多么? 德国人来了就成天潜水:意大利人来了就整天晒日光浴:中国人来了挨个问:有WiFi么?WiFi密码多少? ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
